<?php
if ( ! class_exists( 'Printing_Press_Plugin_Activation_WPElemento_Importer' ) ) {
    /**
     * Printing_Press_Plugin_Activation_WPElemento_Importer initial setup
     *
     * @since 1.6.2
     */

    class Printing_Press_Plugin_Activation_WPElemento_Importer {

        private static $printing_press_instance;
        public $printing_press_action_count;
        public $printing_press_recommended_actions;

        /** Initiator **/
        public static function get_instance() {
          if ( ! isset( self::$printing_press_instance) ) {
            self::$printing_press_instance = new self();
          }
          return self::$printing_press_instance;
        }

        /*  Constructor */
        public function __construct() {

            add_action( 'admin_enqueue_scripts', array( $this, 'enqueue_scripts' ) );

            // ---------- wpelementoimpoter Plugin Activation -------
            add_filter( 'printing_press_recommended_plugins', array($this, 'printing_press_recommended_elemento_importer_plugins_array') );

            $printing_press_actions                   = $this->printing_press_get_recommended_actions();
            $this->printing_press_action_count        = $printing_press_actions['count'];
            $this->printing_press_recommended_actions = $printing_press_actions['actions'];

            add_action( 'wp_ajax_create_pattern_setup_builder', array( $this, 'create_pattern_setup_builder' ) );
        }

        public function printing_press_recommended_elemento_importer_plugins_array($printing_press_plugins){
            $printing_press_plugins[] = array(
                    'name'     => esc_html__('WPElemento Importer', 'printing-press'),
                    'slug'     =>  'wpelemento-importer',
                    'function' => 'WPElemento_Importer_ThemeWhizzie',
                    'desc'     => esc_html__('We highly recommend installing the WPElemento Importer plugin for importing the demo content with Elementor.', 'printing-press'),               
            );
            return $printing_press_plugins;
        }

        public function enqueue_scripts() {
            wp_enqueue_script('updates');      
            wp_register_script( 'printing-press-plugin-activation-script', esc_url(get_template_directory_uri()) . '/includes/getstart/js/plugin-activation.js', array('jquery') );
            wp_localize_script('printing-press-plugin-activation-script', 'printing_press_plugin_activate_plugin',
                array(
                    'installing' => esc_html__('Installing', 'printing-press'),
                    'activating' => esc_html__('Activating', 'printing-press'),
                    'error' => esc_html__('Error', 'printing-press'),
                    'ajax_url' => esc_url(admin_url('admin-ajax.php')),
                    'wpelementoimpoter_admin_url' => esc_url(admin_url('admin.php?page=wpelemento-importer-tgmpa-install-plugins')),
                    'addon_admin_url' => esc_url(admin_url('admin.php?page=wpelementoimporter-wizard'))
                )
            );
            wp_enqueue_script( 'printing-press-plugin-activation-script' );

        }

        // --------- Plugin Actions ---------
        public function printing_press_get_recommended_actions() {

            $printing_press_act_count  = 0;
            $printing_press_actions_todo = get_option( 'recommending_actions', array());

            $printing_press_plugins = $this->printing_press_get_recommended_plugins();

            if ($printing_press_plugins) {
                foreach ($printing_press_plugins as $printing_press_key => $printing_press_plugin) {
                    $printing_press_action = array();
                    if (!isset($printing_press_plugin['slug'])) {
                        continue;
                    }

                    $printing_press_action['id']   = 'install_' . $printing_press_plugin['slug'];
                    $printing_press_action['desc'] = '';
                    if (isset($printing_press_plugin['desc'])) {
                        $printing_press_action['desc'] = $printing_press_plugin['desc'];
                    }

                    $printing_press_action['name'] = '';
                    if (isset($printing_press_plugin['name'])) {
                        $printing_press_action['title'] = $printing_press_plugin['name'];
                    }

                    $printing_press_link_and_is_done  = $this->printing_press_get_plugin_buttion($printing_press_plugin['slug'], $printing_press_plugin['name'], $printing_press_plugin['function']);
                    $printing_press_action['link']    = $printing_press_link_and_is_done['button'];
                    $printing_press_action['is_done'] = $printing_press_link_and_is_done['done'];
                    if (!$printing_press_action['is_done'] && (!isset($printing_press_actions_todo[$printing_press_action['id']]) || !$printing_press_actions_todo[$printing_press_action['id']])) {
                        $printing_press_act_count++;
                    }
                    $printing_press_recommended_actions[] = $printing_press_action;
                    $printing_press_actions_todo[]        = array('id' => $printing_press_action['id'], 'watch' => true);
                }
                return array('count' => $printing_press_act_count, 'actions' => $printing_press_recommended_actions);
            }

        }

        public function printing_press_get_recommended_plugins() {

            $printing_press_plugins = apply_filters('printing_press_recommended_plugins', array());
            return $printing_press_plugins;
        }

        public function printing_press_get_plugin_buttion($slug, $name, $function) {
                $printing_press_is_done      = false;
                $printing_press_button_html  = '';
                $printing_press_is_installed = $this->is_plugin_installed($slug);
                $printing_press_plugin_path  = $this->get_plugin_basename_from_slug($slug);
                $printing_press_is_activeted = (class_exists($function)) ? true : false;
                if (!$printing_press_is_installed) {
                    $printing_press_plugin_install_url = add_query_arg(
                        array(
                            'action' => 'install-plugin',
                            'plugin' => $slug,
                        ),
                        self_admin_url('update.php')
                    );
                    $printing_press_plugin_install_url = wp_nonce_url($printing_press_plugin_install_url, 'install-plugin_' . esc_attr($slug));
                    $printing_press_button_html        = sprintf('<a class="printing-press-plugin-install install-now button-secondary button" data-slug="%1$s" href="%2$s" aria-label="%3$s" data-name="%4$s">%5$s</a>',
                        esc_attr($slug),
                        esc_url($printing_press_plugin_install_url),
                        sprintf(esc_html__('Install %s Now', 'printing-press'), esc_html($name)),
                        esc_html($name),
                        esc_html__('Install & Activate', 'printing-press')
                    );
                } elseif ($printing_press_is_installed && !$printing_press_is_activeted) {

                    $printing_press_plugin_activate_link = add_query_arg(
                        array(
                            'action'        => 'activate',
                            'plugin'        => rawurlencode($printing_press_plugin_path),
                            'plugin_status' => 'all',
                            'paged'         => '1',
                            '_wpnonce'      => wp_create_nonce('activate-plugin_' . $printing_press_plugin_path),
                        ), self_admin_url('plugins.php')
                    );

                    $printing_press_button_html = sprintf('<a class="printing-press-plugin-activate activate-now button-primary button" data-slug="%1$s" href="%2$s" aria-label="%3$s" data-name="%4$s">%5$s</a>',
                        esc_attr($slug),
                        esc_url($printing_press_plugin_activate_link),
                        sprintf(esc_html__('Activate %s Now', 'printing-press'), esc_html($name)),
                        esc_html($name),
                        esc_html__('Activate', 'printing-press')
                    );
                } elseif ($printing_press_is_activeted) {
                    $printing_press_button_html = sprintf('<div class="action-link button disabled"><span class="dashicons dashicons-yes"></span> %s</div>', esc_html__('Active', 'printing-press'));
                    $printing_press_is_done     = true;
                }

                return array('done' => $printing_press_is_done, 'button' => $printing_press_button_html);
            }
        public function is_plugin_installed($slug) {
            $printing_press_installed_plugins = $this->get_installed_plugins(); // Retrieve a list of all installed plugins (WP cached).
            $printing_press_file_path         = $this->get_plugin_basename_from_slug($slug);
            return (!empty($printing_press_installed_plugins[$printing_press_file_path]));
        }
        public function get_plugin_basename_from_slug($slug) {
            $printing_press_keys = array_keys($this->get_installed_plugins());
            foreach ($printing_press_keys as $printing_press_key) {
                if (preg_match('|^' . $slug . '/|', $printing_press_key)) {
                    return $printing_press_key;
                }
            }
            return $slug;
        }

        public function get_installed_plugins() {

            if (!function_exists('get_plugins')) {
                require_once ABSPATH . 'wp-admin/includes/plugin.php';
            }

            return get_plugins();
        }
        public function create_pattern_setup_builder() {

            $edit_page = admin_url().'post-new.php?post_type=page&create_pattern=true';
            echo json_encode(['page_id'=>'','edit_page_url'=> $edit_page ]);

            exit;
        }

    }
}
/**
 * Kicking this off by calling 'get_instance()' method
 */
Printing_Press_Plugin_Activation_WPElemento_Importer::get_instance();